--Quick & Dirty temp. code


utility Gridify "Gridify Object"
(

group "Info..."
	(
	label line1 "Subdivide Mesh Utility"
	label line5 "Ver 0.3b - 12/11/1998"
	label line2 "Idea By Troy Robinson"
	label line3 "tigger@winternet.com"
	label line4 "Code by 3DJ Bobo"	
	label line6 "http://gfxcentral.com/bobo/"	
	
	)

local slice_x_array = #()
local slice_y_array = #()
local slice_z_array = #()
local update_slices

local old_x = 2
local old_y = 2
local old_z = 2

local mesh_selected_yes = false


fn check_for_mesh obj = (superclassof obj == geometryClass and classof obj != target)

	pickButton pick_object "Pick Object" width:140 filter:check_for_mesh align:#center 

	Button set_selection "Set Face Selection" width:140 enabled:false align:#center 
	checkbutton use_selection "Use Face Selection" highlightcolor:([255,128,128] as color) width:140  align:#center 
	
	
Group "X Axis"
	(
	checkbox X_yes "On" checked:false  across:3 align:#left
	Spinner X_segs "#" range:[2,20,2] fieldwidth:30 align:#center type:#integer
	Spinner X_off "" range:[-99,99,0] fieldwidth:30 align:#right type:#integer
	
	checkbutton X_b_min "MIN" width:40 height:16 across:3 align:#left
	Spinner X_bias "" range:[1,99,50] fieldwidth:40 align:#center type:#integer
	checkbutton X_b_max "MAX" width:40 height:16 align:#right
)

Group "Y Axis"
	(
	
	checkbox Y_yes "On" checked:false across:3
	Spinner Y_segs "#" range:[2,20,2] fieldwidth:30 align:#center  type:#integer
	Spinner Y_off "" range:[-99,99,0] fieldwidth:30 align:#right type:#integer
	
	checkbutton Y_b_min "MIN" width:40 height:16 across:3 align:#left
	Spinner Y_bias "" range:[1,99,50] fieldwidth:40 align:#center type:#integer
	checkbutton Y_b_max "MAX" width:40 height:16 align:#right

)
Group "Z Axis"
	(
		
	checkbox Z_yes "On" checked:false across:3
	Spinner Z_segs "#" range:[2,20,2] fieldwidth:30 align:#center type:#integer
	Spinner Z_off "" range:[-99,99,0] fieldwidth:30 align:#right type:#integer
	
	checkbutton Z_b_min "MIN" width:40 height:16 across:3 align:#left
	Spinner Z_bias "" range:[1,99,50] fieldwidth:40 align:#center type:#integer
	checkbutton Z_b_max "MAX" width:40 height:16 align:#right
)
	
	
	Button Slice_object "COLLAPSE MESH" width:140 height:30 enabled:false

on set_selection pressed do
(
go_select = true
if object_to_slice.modifiers.count >0 then
(
go_select = false

q = querybox "Before selecting new faces,\nyou should COLLAPSE THE MESH first.\nDo you want to do this?"
if q then 
	(
	undo on
	(
	converttomesh object_to_slice
	X_yes.checked = false
	Y_yes.checked = false
	Z_yes.checked = false
	use_selection.checked = false
	
	)

	go_select = true
	)

)

if go_select then
(
s_m =mesh_select ()
addmodifier object_to_slice s_m	

--max vpt persp user
--select object_to_slice
--max zoomext sel
max modify mode 
select object_to_slice
subObjectLevel = 2
mesh_selected_yes = true
)
)





on use_selection changed state do
(
g_f_s = getfaceselection object_to_slice
if g_f_s.count != 0 then 

(

if state then 
	(

if X_Yes.checked then
	(	
		for i = 2 to old_x do
			(
			deletemodifier object_to_slice slice_x_array[i]
			)
	)	

if Y_Yes.checked then
	(	
		for i = 2 to old_y do
			(
			deletemodifier object_to_slice slice_y_array[i]
			)
	)	
if Z_Yes.checked then
	(	
		for i = 2 to old_z do
			(
			deletemodifier object_to_slice slice_z_array[i]
			)
	)	

	
	m_s =mesh_select ()
	addmodifier object_to_slice m_s
	subObjectLevel = 2
	
	s_m1 =slice ()
	addmodifier object_to_slice s_m1
	bbox_min = GetModContextBBoxMin object_to_slice s_m1
	bbox_max = GetModContextBBoxMax object_to_slice s_m1


if X_Yes.checked then
	(	
		for i = 2 to old_x do
			(
			s_m = slice  ()
			slice_x_array[i]= s_m
			addmodifier object_to_slice slice_x_array[i]			
			)
		update_slices x_segs.value y_segs.value z_segs.value true false false
	)	


if Y_Yes.checked then
	(	
		for i = 2 to old_y do
			(
			s_m = slice  ()
			slice_y_array[i]= s_m
			addmodifier object_to_slice slice_y_array[i]			
			)
		update_slices x_segs.value y_segs.value z_segs.value false true false
	)	


if Z_Yes.checked then
	(	
		for i = 2 to old_z do
			(
			s_m = slice  ()
			slice_z_array[i]= s_m
			addmodifier object_to_slice slice_z_array[i]			
			)
		update_slices x_segs.value y_segs.value z_segs.value false false true
	)	
	
	
	
	)
	 else 
	 (
 	 deletemodifier object_to_slice s_m1
	 deletemodifier object_to_slice m_s
	 )
)
else
(
use_selection.checked = false

)
)


On pick_object picked obj do
	(
	object_to_slice = obj
	pick_object.text = obj.name
	Slice_object.enabled = true
	set_selection.enabled = true
	)
	
On slice_object pressed do
	(
	undo on
	(
	converttomesh object_to_slice
	X_yes.checked = false
	Y_yes.checked = false
	Z_yes.checked = false
	use_selection.checked = false
	
	)
	)
	
	
on X_segs changed value do
	(
if X_Yes.checked then
	(	
		for i = 2 to old_x do
			(
			deletemodifier object_to_slice slice_x_array[i]
			)
	
		for i = 2 to value do
			(
			s_m = slice  ()
			slice_x_array[i]= s_m
			addmodifier object_to_slice slice_x_array[i]			
			)
		update_slices x_segs.value y_segs.value z_segs.value true false false
		old_x = value
	)	
)

on X_bias changed value do
	(
if X_Yes.checked then
	(	
		update_slices x_segs.value y_segs.value z_segs.value true false false
	)	
)

on X_b_min changed state do
	(
	if X_b_max.checked and state then X_b_max.checked = false

if X_Yes.checked then
	(	
		update_slices x_segs.value y_segs.value z_segs.value true false false
	)	
)

on X_b_max changed state do
	(
	if X_b_min.checked and state then X_b_min.checked = false
if X_Yes.checked then
	(	
		update_slices x_segs.value y_segs.value z_segs.value true false false
	)	
)

on X_off changed value do
	(
if X_Yes.checked then
	(	
		update_slices x_segs.value y_segs.value z_segs.value true false false
	)	
)


on Y_segs changed value do
	(
	if Y_yes.checked then
	(
		for i = 2 to old_y do
			(
			deletemodifier object_to_slice slice_y_array[i]
			)
	
		for i = 2 to value do
			(
			s_m = slice  ()
			slice_y_array[i]= s_m
			addmodifier object_to_slice slice_y_array[i]
			)
		update_slices x_segs.value y_segs.value z_segs.value false true false
		old_y = value
	)	
)

on Y_bias changed value do
	(
	if Y_yes.checked then
	(
		update_slices x_segs.value y_segs.value z_segs.value false true false
	)	
)


on Y_b_min changed state do
	(
	if Y_b_max.checked and state then Y_b_max.checked = false

if Y_Yes.checked then
	(	
		update_slices x_segs.value y_segs.value z_segs.value false true false 
	)	
)

on Y_b_max changed state do
	(
	if Y_b_min.checked and state then Y_b_min.checked = false
if Y_Yes.checked then
	(	
		update_slices x_segs.value y_segs.value z_segs.value false true false
	)	
)


on Y_off changed value do
	(
	if Y_yes.checked then
	(
		update_slices x_segs.value y_segs.value z_segs.value false true false
	)	
)



on Z_segs changed value do
	(
if Z_yes.checked then
	(
		for i = 2 to old_z do
			(
			deletemodifier object_to_slice slice_z_array[i]
			)
	
		for i = 2 to value do
			(
			s_m = slice  ()
			slice_z_array[i]= s_m
			addmodifier object_to_slice slice_z_array[i]		
			)
		update_slices x_segs.value y_segs.value z_segs.value false false true
		old_z = value
	)	
)

on Z_bias changed value do
	(
if Z_yes.checked then
	(
		update_slices x_segs.value y_segs.value z_segs.value false false true
	)	
)


on Z_b_min changed state do
	(
	if Z_b_max.checked and state then Z_b_max.checked = false

if Z_Yes.checked then
	(	
		update_slices x_segs.value y_segs.value z_segs.value false false true 
	)	
)

on Z_b_max changed state do
	(
	if Z_b_min.checked and state then Z_b_min.checked = false
if Z_Yes.checked then
	(	
		update_slices x_segs.value y_segs.value z_segs.value false false true
	)	
)


on Z_off changed value do
	(
if Z_yes.checked then
	(
		update_slices x_segs.value y_segs.value z_segs.value false false true
	)	
)


on X_yes changed state do
	(
		if state then
		(
		for i = 2 to x_segs.value do
			(
			s_m = slice  ()
			slice_x_array[i]= s_m
			addmodifier object_to_slice slice_x_array[i]		
			)
		update_slices x_segs.value y_segs.value z_segs.value true false false
		)
		else
		(
		for i = 2 to x_segs.value do
			(
			deletemodifier object_to_slice slice_x_array[i]
			)
		
		)
	)
	





on Y_yes changed state do
	(
		if state then
		(
		for i = 2 to y_segs.value do
			(
			s_m = slice  ()
			slice_y_array[i]= s_m
			addmodifier object_to_slice	slice_y_array[i]
			)
		update_slices x_segs.value y_segs.value z_segs.value false true false
		)
		else
		(
		for i = 2 to y_segs.value do
			(
			deletemodifier object_to_slice slice_y_array[i]
			)
		
		)
	)

on Z_yes changed state do
	(
		if state then
		(
		for i = 2 to z_segs.value do
			(
			s_m = slice  ()
			slice_z_array[i]= s_m
			addmodifier object_to_slice	slice_z_array[i]
			)
		update_slices x_segs.value y_segs.value z_segs.value false false true
		)
		else
		(
		for i = 2 to z_segs.value do
			(
			deletemodifier object_to_slice slice_z_array[i]
			)
		
		)
	)




fn update_slices x_sl y_sl z_sl upd_x upd_y upd_z =
	( 

	if X_yes.checked and upd_x then
	(		
	for i = 2 to X_sl do
		(
		if not use_selection.checked then
		(		
		bbox_min = GetModContextBBoxMin object_to_slice slice_x_array[i]
		bbox_max = GetModContextBBoxMax object_to_slice slice_x_array[i]
		)
	
		offset_x = (X_off.value as float/100) * ((bbox_max.x-bbox_min.x)/X_sl)
		
		if X_b_min.checked then
		(
		bbox_mid = [offset_x+bbox_min.x+((((100-X_bias.value)as float/100)*(i-1))*(bbox_max.x-bbox_min.x)/X_sl)*(i-1),bbox_min.y,bbox_min.z]
		)
		
		if X_b_max.checked then
		(
		bbox_mid = [-offset_x+bbox_max.x-((((100-X_bias.value)as float/100)*(i-1))*(bbox_max.x-bbox_min.x)/X_sl)*(i-1),bbox_min.y,bbox_min.z]
		)
		
		if not X_b_max.checked and not X_b_min.checked then
		(
		bbox_mid = [offset_x+bbox_min.x+((bbox_max.x-bbox_min.x)/X_sl)*(i-1),bbox_min.y,bbox_min.z]
		)

		slice_x_array[i][1][1].value = bbox_mid		
		slice_x_array[i][1][2].value = quat 90 [0,1,0]
		)--end i loop
	)
	
	if Y_yes.checked and upd_y then
	(
	for i = 2 to Y_sl do
		(
		if not use_selection.checked then
		(		
		bbox_min = GetModContextBBoxMin object_to_slice slice_y_array[i]
		bbox_max = GetModContextBBoxMax object_to_slice slice_y_array[i]
		)
		
		offset_y = (Y_off.value as float /100) * ((bbox_max.y-bbox_min.y)/Y_sl)

		if Y_b_min.checked then
		(
		bbox_mid = [bbox_min.x,offset_y+bbox_min.y+((((100-Y_bias.value)as float/100)*(i-1))*(bbox_max.y-bbox_min.y)/Y_sl)*(i-1),bbox_min.z]
		)
		
		if Y_b_max.checked then
		(
		bbox_mid = [bbox_min.x, -offset_y+bbox_max.y-((((100-Y_bias.value)as float/100)*(i-1))*(bbox_max.y-bbox_min.y)/Y_sl)*(i-1),bbox_min.z]
		)
		
		if not Y_b_max.checked and not Y_b_min.checked then
		(
		bbox_mid = [bbox_min.x,offset_y+bbox_min.y+((bbox_max.y-bbox_min.y)/Y_sl)*(i-1),bbox_min.z]
		)



		slice_y_array[i][1][1].value = bbox_mid
		slice_y_array[i][1][2].value = quat 90 [1,0,0]		
		)--end i loop
	)
	
	
		if Z_yes.checked and upd_z then
	(
	for i = 2 to Z_sl do
		(
		if not use_selection.checked then
		(
		bbox_min = GetModContextBBoxMin object_to_slice slice_z_array[i]
		bbox_max = GetModContextBBoxMax object_to_slice slice_z_array[i]
		)

		offset_z = (Z_off.value as float /100) * ((bbox_max.z-bbox_min.z)/Z_sl)


		if Z_b_min.checked then
		(
		bbox_mid = [bbox_min.x,bbox_min.y,offset_z+bbox_min.z+((((100-Z_bias.value)as float/100)*(i-1))*(bbox_max.z-bbox_min.z)/Z_sl)*(i-1)]
		)
		
		if Z_b_max.checked then
		(
		bbox_mid = [bbox_min.x,bbox_min.y, -offset_z+bbox_max.z-((((100-Z_bias.value)as float/100)*(i-1))*(bbox_max.z-bbox_min.z)/Z_sl)*(i-1)]
		)
		
		if not Z_b_max.checked and not Z_b_min.checked then
		(
		bbox_mid = [bbox_min.x,bbox_min.y, offset_z+bbox_min.z+((bbox_max.z-bbox_min.z)/Z_sl)*(i-1)]
		)

		slice_z_array[i][1][1].value = bbox_mid
		)--end i loop
	)
)--end fn		
	
	
)--end util